﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SE.GOV.MM.Integration.Log
{
    /// <summary>
    /// Simple class to write to eventLog
    /// </summary>
    internal static class EventLogWriter
    {
        private static EventLog _eventLog = new EventLog();
        private static string Source { get { return ConfigurationManager.AppSettings["ApplicationName"]; } }


        /// <summary>
        /// Writes Error to eventlog
        /// </summary>
        /// <param name="log"></param>
        public static void WriteExceptionToEventLog(Log log)
        {
            var errorMessage = string.Format("{0}{1}{2}", log.Message, Environment.NewLine, log.Exception);
            _eventLog.Source = Source;
            _eventLog.WriteEntry(errorMessage, EventLogEntryType.Error, (int)log.EventId);
        }


        /// <summary>
        /// Writes Warning to eventlog
        /// </summary>
        /// <param name="log"></param>
        public static void WriteWarningToEventLog(Log log)
        {
            _eventLog.Source = Source;
            _eventLog.WriteEntry(log.Message, EventLogEntryType.Warning, (int)log.EventId);
        }


        /// <summary>
        /// Writes information to eventlog
        /// </summary>
        /// <param name="log"></param>
        public static void WriteInfoToEventLog(Log log)
        {
            _eventLog.Source = Source;
            _eventLog.WriteEntry(log.Message, EventLogEntryType.Information, (int)log.EventId);
        }
    }
}
